$PRINT
$NOSYMBOLS

;****************************************************************************
;
;	    MICROPAC 535 INITIALIZATION AND DRIVER ROUTINES
;
;		     COPYRIGHT 1993-1994 EMAC INC.
;
;****************************************************************************


;
; Change STARD to 0 to make ROMable code.  All user routines that
; reference data within the ROM must use the MOVC command instead
; of MOVX.
;
STARD    EQU      8000H		; start address for program
;STARD     EQU         0H		; start address for program
$INCLUDE(mod515)
;$INCLUDE(SEEPROM1.asm)



         ; VALUES FOR P2 TO CHIP-SELECT DEVICES

LCDSEL   EQU      28H               ; LCD PORT
KEYSEL   EQU      38H               ; KEYPAD PORT
Y4SEL    EQU      48H
Y5SEL    EQU      58H
Y6SEL    EQU      68H
EXTIO    EQU      78H
         
; SCB2681 PORTS
MR1A     EQU      00H      ; MODE REGISTER A (MR1A, MR2A)
SRA      EQU      01H      ; STATUS REGISTER A
CSRA     EQU      01H      ; CLOCK SELECT REGISTER A (WR)
BRGTST   EQU      02H      ; BRG TEST
CRA      EQU      02H      ; COMMAND REGISTER A (WR)

RHRA     EQU      03H      ; RX HOLDING REGISTER A
THRA     EQU      03H      ; TX HOLDING REGISTER A (WR)
IPCR     EQU      04H      ; INPUT  PORT CHANGE REGISTER
ACR      EQU      04H      ; AUX CONTROL REGISTER (WR)

ISR      EQU      05H      ; INTERRUPT STATUS REG.
IMR      EQU      05H      ; INTERRUPT MASK REG. (WR)
CTU      EQU      06H      ; COUNTER TIMER UPPER
CTUR     EQU      06H      ; COUNTER TIMER UPPER READ (WR)

CTL      EQU      07H      ; COUNTER TIMER LOWER
CTLR     EQU      07H      ; COUNTER TIMER LOWER READ (WR)
MR1B     EQU      08H      ; MODE REGISTER B
SRB      EQU      09H      ; STATUS REGISTER B
CSRB     EQU      09H      ; CLOCK SELECT REGISTER B (WR)
TST1X16  EQU      0AH      ; 1X/16X TEST
CRB      EQU      0AH      ; COMMAND REGISTER B       (WR)
RHRB     EQU      0BH      ; RX HOLDING REGISTER B
THRB     EQU      0BH      ; TX HOLDING REGISTER B (WR)
UARTIN   EQU      0DH      ; INPUT PORT
OPCR     EQU      0DH      ; OUTPUT PORT CONF. REG. (WR)
STRTCNT  EQU      0EH      ; START COUNTER COMMAND
OUTSET   EQU      0EH      ; SET OUTPUT PORT BITS COMMAND
STOPCNT  EQU      0FH      ; STOP COUNTER COMMAND
OUTRES   EQU      0FH      ; RESET OUTPUT PORT BITS COMMAND (WR)


;515c registers

;serial registers
ADCON0	 equ	 0d8h
SRELL	 equ	 0AAh
SRELH	 equ	 0BAh

;A to D registers
ADCON1	 equ	 0DCh
ADDATL	 equ	 0DAh
ADDATH	 equ	 0D9h
ABSY	 equ 	 ADCON0.4


DACSEL	EQU	18H		; D/A SELECT
escflag	equ	psw.5	;status 0 bit for lcd status


cr       equ      0dh               ; ascii carriage return
lf       equ      0ah               ; ascii line feed
esc      equ      1bh               ; ASCII  escape
         
         ORG      stard
         JMP      INIT


	;
	; INTERRUPT HANDLER VECTORS
	;
	; Put the handler code in the areas marked "HANDLER CODE"
	; if the handler is 8 bytes or less otherwise insert an LJMP
	; to larger handler 
	;
	org	stard+03H   ; IE0
	; HANDLER CODE

	org	stard+0BH   ; TF0
	; HANDLER CODE

	org	stard+13H   ; IE1
	; HANDLER CODE

	org	stard+1BH   ; TF1
	; HANDLER CODE

	org	stard+23H   ; RI/TI
	; HANDLER CODE

	org	stard+2BH   ; TF2/EXF2
	; HANDLER CODE

	org	stard+43H   ; IADC
	; HANDLER CODE

	org	stard+4BH   ; IEX2
	; HANDLER CODE

	org	stard+53H   ; IEX3
	; HANDLER CODE

	org	stard+5BH   ; IEX4
	; HANDLER CODE

	org	stard+63H   ; IEX5
	; HANDLER CODE

	org	stard+6BH   ; IEX6
	; HANDLER CODE

	org	stard+7BH   ; Wake-up
	; HANDLER CODE

	org	stard+8BH   ; CAN
	; HANDLER CODE

	org	stard+93H   ; SSC TC/WCOL
	; HANDLER CODE

	org	stard+0A3H   ; External
	; HANDLER CODE

	org	stard+0ABH   ; External
	; HANDLER CODE




$INCLUDE(SEEPROM1.asm)	;include in the serial eeprom code
$include(lcddrv3.asm)


;===============================================================
; Serial Port Functions 
; 
; 
;===============================================================


;
; PSTRING: Print to COM0 the string in code memory pointed to by DPTR.
;	  The end of the string is denoted by 0 hex.  DPTR is returned
;	  pointing to the byte following the 0.
;
PSTRING:
	PUSH	ACC
PSTRN0:	CLR	A
	MOVC	A,@A+DPTR	; GET CHAR FROM MEM
	INC	DPTR
	JZ	PSTRN1	; IF ACC=0, EXIT
	CALL	COM0OUT	; PRINT CHAR
	JMP	PSTRN0	; NEXT CHAR
PSTRN1:	POP	ACC
	RET


PSTRING1:
	PUSH	ACC
PSTRN01:	CLR	A
	MOVC	A,@A+DPTR	; GET CHAR FROM MEM
	INC	DPTR
	JZ	PSTRN11	; IF ACC=0, EXIT
	CALL	SEROUTA	; PRINT CHAR
	JMP	PSTRN01	; NEXT CHAR
PSTRN11:	POP	ACC
	RET

PSTRING2:
	PUSH	ACC
PSTRN02:	CLR	A
	MOVC	A,@A+DPTR	; GET CHAR FROM MEM
	INC	DPTR
	JZ	PSTRN12	; IF ACC=0, EXIT
	CALL	SEROUTB	; PRINT CHAR
	JMP	PSTRN02	; NEXT CHAR
PSTRN12:	POP	ACC
	RET


PSTRINGlcd:
	PUSH	ACC
PSTRNlcd1:	CLR	A
	MOVC	A,@A+DPTR	; GET CHAR FROM MEM
	INC	DPTR
	JZ	PSTRNlcd11	; IF ACC=0, EXIT
	CALL	lcdout	; PRINT CHAR
	JMP	PSTRNlcd1	; NEXT CHAR
PSTRNlcd11:	POP	ACC
	RET





;
; CRLFA: SEND CR/LF TO SERIAL PORT A
;
CRLFA:   MOV      A,#CR
         CALL     SEROUTA
         MOV      A,#LF
         CALL     SEROUTA
         RET
         

;
; CARRIAGE RETURN, LINE FEED TO com0
;
CRLF:    PUSH     ACC
         MOV      A,#CR
         CALL     com0OUT
         MOV      A,#LF
         CALL     com0OUT
         POP      ACC
         RET

;
; com0OUT: Output the char in ACC to com0
;      
com0OUT:

         JNB      TI,$              ; WAIT TILL BUFFER EMPTY 
         CLR      TI                ; CLEAR FLAG
         MOV      SBUF,A            ; SEND THE CHAR
         RET


;        
; com0IN: Return a char in ACC from com0
;                  
com0IN:
         JNB      RI,$              ; Wait for receiver flag.
         CLR      RI                ; Clear receiver flag.
         MOV      A,SBUF            ; Read character.
         RET



;
; Serial port A input
;
SERINA:  
	PUSH	DPH
         MOV      DPH,#SRA
SERINA1: MOVX     A,@DPTR
         JNB      ACC.0,SERINA1     ; LOOP TILL RXrdy
         MOV      DPH,#RHRA          ; READ DATA PORT
         MOVX     A,@DPTR
	POP	DPH
         RET

;
; Serial port B input
;
SERINB:  
         MOV      P2,#SRB
SERINB1: MOVX     A,@R1
         JNB      ACC.0,SERINB1     ; LOOP TILL RXrdy
         MOV      P2,#RHRB          ; READ DATA PORT
         MOVX     A,@R1
         RET
         
;
;Serial port A output
;
SEROUTA:
         MOV      P2,#SRA
         PUSH     ACC               ; SAVE CHAR
SOUTA1:  MOVX     A,@R1
         JNB      ACC.2,SOUTA1      ; LOOP TILL TXrdy
         POP      ACC
         MOV      P2,#THRA          ; SEND IT OUT
         MOVX     @R1,A
         RET

;
;Serial port B output
;
SEROUTB:
         MOV      P2,#SRB
         PUSH     ACC               ; SAVE CHAR
SOUTB1:  MOVX     A,@R1
         JNB      ACC.2,SOUTB1      ; LOOP TILL TXrdy
         POP      ACC
         MOV      P2,#THRB          ; SEND IT OUT
         MOVX     @R1,A
         RET


;
; SHOW dptr on com0 as HEX
;
shdptr:  
         push     acc
         mov      a,dph
         call     hex2
         mov      a,dpl
         call     hex2
         pop      acc
         ret
          
HEX2:    PUSH     ACC      ; SAVE BYTE
         SWAP     A
         CALL     HXD
         POP      ACC
         CALL     HXD
         RET

; convert ascii to hex OBVIOSLY NOT FINISHED NZG
A2HEX:	PUSH	ACC
		
	
	


; CONVERT LOWER NIBBLE IN A TO ASCII AND DISPLAY IT
HXD:     ;ANL      A,#0FH      
         ;ADD      A,#90H     ; SET UP SO A-F MAKE CARRY
         ;DA       A
         ;ADDC     A,#40H
         ;DA       A
         CALL	HEXL
	CALL     COM0OUT    ; Display digit
         RET

; CONVERT LOWER NIBBLE IN A TO ASCII in A
HEXL:	ANL      A,#0FH      
         ADD      A,#90H     ; SET UP SO A-F MAKE CARRY
         DA       A
         ADDC     A,#40H
         DA       A
	RET

;CONVERT UPPER NIBBLE IN A TO ASCII in A
HEXH:	
	SWAP	A
	CALL	HEXL
	RET   




;***************************************************************************
;		      START OF INITIALIZATION
;
;***************************************************************************
;NZG modifications for the 515c 5/10/02
         
INIT:    MOV      IEN0,#0           ; DISABLE ALL INTS
         MOV      SP,#5fH           ; INIT STACK
         
         CLR      P5.1              ; ENABLE MMIO 
         CLR      P5.2              ; DISABLE EEPROM
         
         ; com0 setup 
         MOV      A,PCON            ; Make sure SMOD is off.
         CLR      ACC.7
         MOV      PCON,A
	ORL	ADCON,#80h
	MOV	SRELL,#0DFh
         MOV	SRELH,#03h
	MOV      SCON,#52h         ; Set up serial port.

         ;
         ; SET UP SCN2681 (IT MAY NOT EXIST)
         ; NO PARITY, ONE STOP BIT AND 8 DATA
         ;
MR1ADAT  EQU  00010011B ; no RTS, Rx int on RxRDY, char mode, no parity, 8 data
MR2ADAT  EQU  00000111B ; normal,no TxRTS, no CTS, 1 stop bit
MR1BDAT  EQU  00010011B ; no RTS, Rx int on RxRDY, char mode, no parity, 8 data
MR2BDAT  EQU  00000111B ; normal,no TxRTS, no CTS, 1 stop bit

	CALL	DLAYL		;Initialization Delay
	CALL	DLAYL
	CALL	DLAYL
  



       ; DO RESET COMMANDS FOR PORTS A AND B
         MOV      A,#01010000B      ; DO FROM THIS COMMAND, DOWN TO 00010000
CRINIT:  MOV      P2,#CRA
         MOVX     @R1,A
         MOV      P2,#CRB
         MOVX     @R1,A
         ADD      A,#-16            ; SUBTRACT 1 FROM UPPER NIBBLE
         JNZ      CRINIT            ; LOOP TILL 0

         
         MOV      P2,#MR1A          ; SETUP PROTOCAL FOR PORT A
         MOV      A,#MR1ADAT
         MOVX     @R1,A
         MOV      A,#MR2ADAT
         MOVX     @R1,A
         
         MOV      P2,#MR1B          ; SETUP PROTOCAL FOR PORT B
         MOV      A,#MR1BDAT
         MOVX     @R1,A
         MOV      A,#MR2BDAT
         MOVX     @R1,A

         MOV      P2,#ACR
         MOV      A,#80H
         MOVX     @R1,A             ; SET 2 OF BRG
         
         MOV      P2,#CSRA
         MOV      A,#10111011B       
         MOVX     @R1,A             ; RX AND TX AT 9600 FOR A
         MOV      P2,#CSRB
         MOVX     @R1,A             ; RX AND TX AT 9600 FOR B
         
         MOV      P2,#CRA
         MOV      A,#00000101B       ; ENABLE TXER AND RXER
         MOVX     @R1,A
         MOV      P2,#CRB
         MOVX     @R1,A             ; SAME FOR B
         
         MOV      P2,#OPCR          ; SET UP OP2-7 SO THEY'RE CONTROLLED...
         MOV      A,#0              ; BY OUTSET AND OUTRES
         MOVX     @R1,A             ; 
         
;==============================================
;
; Start of test code
;
;==============================================         

	if	1
;****************************************************
; Display Table
testr:
	mov	dptr,#msg1
	call	pstring	; print message
	mov	dptr,#adt
	call	pstring	; print message
	mov	dptr,#comp
	call	pstring	; print message
	mov	dptr,#eemes
	call	pstring	; print message
	mov	dptr,#lcdmes
	call	pstring	; print message
	mov	dptr,#dacmes
	call	pstring
	mov	dptr,#diomes
	call	pstring



	call	com0in	; get character
	call	com0out	; show character
	cjne	a,#061h, nota 
;analog to digital test
	mov	dptr,#msg2	;print AtoD header
	call	pstring
loop0:	mov	b,#8
loop1:	dec	b	; dec channel
	mov	a,b	; send channel to ACC
	push	b
	call	adcin10
	push	acc
	mov	a,b	;display msb first
	call	hex2	; show channel value
	pop	acc
	call	hex2
	mov	a,#' '
	call	com0out	; print a space
	pop	b
	mov	a,b	; send channel to ACC
	jnz	loop1
	mov	a,#0dh	; print cr
	call	com0out
	jmp	loop0	; print data on same line

nota:	cjne	a,#062h, notb	
;serial test
	mov	dptr,#sprom1
	call	pstring

LUP21:         
         CALL     SERINA
         CALL     SEROUTA
         cjne	a,#71h, LUP21
	  	

	mov	dptr,#sprom2
	call	pstring
LUP22:         
         CALL     SERINB
         CALL     SEROUTB
         cjne	a,#71h, LUP22
	   jmp		dflt


;EEPROM TEST
notb:	
	cjne	a,#063h, notc
	MOV	A,#255 	;SET UP DATA, START ADDRESS(255) AND ENABLE EEPROM
	CALL	ewen
	MOV	DATA_HI,#043H
	MOV	DATA_LO,#021H
	call     crlf	
	
EeL:	PUSH	Acc		;SAVE CURRENT ADDRESS
	mov	dptr,#eewr
	call	pstring
	MOV	ADDR_LO,A
	CALL	WRITE
	CALL	EEDIS
	
		
	mov	dptr,#eerd
	call	pstring
	MOV	DATA_HI,#0
	MOV	DATA_LO,#0	;zero out memory locations
	
	CALL	READ		;read data back
	CALL	EEDIS

	mov      a,#cr
      call     com0out
	POP	Acc
	DJNZ	Acc,EeL	


;LCD TEST
notc:
	cjne	a,#064h, notd
	call	lcdinit
	mov	dptr,#lcdts
	call	pstring
	mov	dptr,#lcdstr
	call	pstringlcd
	
	
;DAC test
notd:
	cjne	a,#065h, note
	mov	dptr,#dacts
	call	pstring
nwav:
	MOV	data_lo,#255
achng:	
	MOV	addr_lo,#4
daco:
	dec	addr_lo
	CALL	LDACOUT
	mov	a,addr_lo
	jnz	daco
	djnz	data_lo,achng
	jmp	nwav



;DIO test
note:
	cjne	a,#066h, notf
	mov	dptr,#diots
	call	pstring
DIOL:	mov	A,#0FFH
	CALL	DIOBYTE		;turn on PX0-PX7
	mov	P1,#0FFH	;turn on PX8-PX15
	ORL	P3,#038H	;turn on PX16-PX18
	
	mov	A,#0	
	CALL	DIOBYTE		;turn on PX0-PX7
	mov	P1,#0		;turn on PX8-PX15
	ANL	P3,#0C7H	;turn on PX16-PX18
	
	jmp	DIOL


notf:
dflt:	jmp	testr



;Write a Byte to PX0-PX7 
DIOBYTE:
	CLR	P5.1		; ENABLE MMIO
	PUSH	ACC
	MOV	A,#Y4SEL		; POINT TO DAC+Inde(x)
	MOV	DPH,A
	POP	ACC
	MOVX	@DPTR,A		; WRITE TO DAC

RET



EEDIS:	;DISPLAY WHAT WAS JUST READ OR WRITTEN AS ADDR=DATA
	MOV	A,ADDR_LO
	CALL	HEX2
	mov      a,#'='
      call     com0out	; and '='

	MOV	A,DATA_HI
	CALL	HEX2
	MOV	A,DATA_LO
	CALL	HEX2
RET





msg1:	db 	cr,lf,'Select a test (caps lock off). ',0
msg2:	db	cr,lf,'07   06   05   04   03   02   01   00   <--- A/D CHANNELS',0DH,0AH,0
adt:	db	cr,lf,lf,'a: Analog to Digital Test',0
comp:	db	cr,lf,'b: Serial Test',0
eemes: 	db	cr,lf,'c: EEprom Test',0
lcdmes:	db	cr,lf,'d: LCD test',0
dacmes:	db	cr,lf,'e: Digital to Analog test',0
diomes:	db	cr,lf,'f: Digital IO Test PX 0-18',cr,lf,0

sprom1:	db	cr,lf,'com1 awaiting input hit q to continue',0
sprom2:	db	cr,lf,'com2 awaiting input hit q to continue',0
ser1:	db	cr,lf,'Com1-',0
ser2:	db	cr,lf,'Com2-',0

eewr:	db	'writing to eeprom location - ',0
eerd:	db	'  reading eeprom location - ',0
lcdstr:	db	01AH,'your lcd is working',0
lcdts:	db	cr,lf,'writing to lcd',0
dacts:	db	cr,lf,'generating sawtooth waves',0
diots:	db	cr,lf,'generating square waves',0

; ADCIN
; Return ACC with the 8 bit A/D conversion from the channel selected by ACC
;NZG modified 5/10/02
ADCIN: 
         ANL      A,#111B           ; ONLY 8 CHANNELS
         ANL      ADCON0,#11000000B  ; MODE FOR A/D CONVERSION: SINGLE
         ORL	ADCON1,#010h	    ; divide by 8 to get available conversion speed at 10Mhz	
	ORL      ADCON,A           ; "OR" IN THE CHANNEL
         MOV      ADDATL,#0           ; START CONV W/NO REF VOLTAGE
         JB       ABSY,$             ; LOOP TILL CONVERTED
         MOV      acc,ADDATH         ; ACC = CONVERSION 
         RET


;         
; ADCIN10: Return B:A with the 10 bit A/D conversion from the channel in ACC
; Note ADCON0 is cleared on reset, so it defaults to single conv mode.
;          
ADCIN10: 
         ANL      A,#111B           ; ONLY 8 CHANNELS
	ORL	A,#80H		; /8 DIVIDE RATIO ON A/D
         MOV      ADCON1,A		; SELECT CHANNEL AND DIVIDE RATIO
	MOV	ADDATL,A		; START CONVERSION
         JB       BSY,$             ; LOOP TILL CONVERTED

         MOV      A,ADDATH          ; ACC = CONVERSION BITS 2->9
	RL	A
	RL	A		; 9,8 ARE IN POSITION 1,0
	ANL	A,#11B		; MASK OFF ALL BUT 1,0
	MOV	B,A		; B=BITS 9,8, RIGHT-JUSTIFIED

	;REPLACE BITS 9,8 WITH BITS 1,0, THEN RL TWICE TILL WE HAVE 7-0 IN ORDER
	MOV	A,ADDATH
	ANL	A,#00111111B
	ORL	A,ADDATL	
	RL	A
	RL	A
         RET





;****************************************************
	endif

        

LDELAY 	EQU	0FEFFH		; 78mS

DLAYL:   PUSH     ACC
	PUSH	B
	MOV	A,#0FFh
	MOV	B,#0FEh
         SJMP     DLAY1

DLAY1:	DJNZ	B,$		
	DJNZ	ACC,DLAY1	
	POP	B		
	POP	ACC		
	RET

;===============================================================
; Write to the DAC.  Format is DACOUT(x)=<expr> where x is a 
; value from 0 to 3 selecting the channel and <expr> is
; a value from 0 to 255.
;===============================================================
LDACOUT:	; expr IN data_lo AND Inde(x) IN addr_lo
	
LDACO1:	CLR	P5.1		; ENABLE MMIO
	PUSH	ACC
	MOV	A,addr_lo
	ADD	A,#DACSEL		; POINT TO DAC+Inde(x)
	MOV	DPH,A
	MOV	A,data_lo
	MOVX	@DPTR,A		; WRITE TO DAC
	POP	ACC
	RET



         END
